我正在学习C语言中的异常处理,以下是我尝试将其应用于动态分配内存的方法:

#include <iostream>

using namespace std;

int main()
{
    const char * message[] = {"Dynamic memory allocation failed! "};
    enum Error{
        MEMORY
    };

    int * arr, length;
    cout << "Enter length of array: " << endl;
    cin >> length;

    try{
        arr = new int[length];
        if(!arr){
            throw MEMORY;
        }
    }
    catch(Error e){
        cout << "Error!" << message[e];
    }
    delete [] arr;
}

它不能正常工作,如果我输入一些巨大的长度,而不是显示消息“动态内存分配失败!”(没有引号)我得到:

terminate called after throwing an instance of ‘std::bad\_alloc’
what(): std::bad\_alloc

This application has requested the Runtime to terminate it in an unusual way.
Please contact the application’s support team for more information.


Process returned 3 (0x3) execution time : 3.835 s
Press any key to continue.

任何的想法?

解决方法:

运算符new本身会抛出错误.并且它的错误不是你指定的类型Error,所以如果无法分配内存,那么你的if语句将永远不会被执行,因为异常将被抛出.

您可以使用if删除块并尝试捕获由new运算符抛出的异常.或者使用std::nothrow

 arr=new (std::nothrow)[length];

运算符分配内存

标签: c, exception-handling, dynamic-memory-allocation

相关文章推荐

添加新评论,含*的栏目为必填